
var genFuncHash = function(name, input) {
	var ret = name + "(";
	for(var i = 0; i < input.length; i++) {
		if(i == input.length - 1) {
			ret += input[i].type;
		} else {
			ret += (input[i].type + ",");
		}
	}
	ret += ")";
	return keccak256(ret).substr(0, 8);
}

var genHex = function(amount) {
	var x = new BigNumber(amount);
	return x.toString(16);
}

var valfromhex64 = function(val) {
	var x = new BigNumber("0x" + val);
	return "0x" + x.toString(16);
}

var parseOutput = function(data, output) {
	var ret = [];
	for(var i = 0; i < output.length; i++) {
		if(output[i].type == "address") {
			ret.push("oc" + data.substr(2 + 64 * i + 24, 64));
		} else {
			ret.push(valfromhex64(data.substr(2 + 64 * i, 64)));
		}
	}
	return ret;
}

var parseTxInfo = function(data) {
	var ret = [];
	ret.push(data.hash);
	ret.push(data.blockNumber);
	ret.push(data.blockHash);
	ret.push(data.from);
	ret.push(data.to);
	ret.push(data.value);
	ret.push(data.gas);
	ret.push(data.gasPrice)
	ret.push(data.time);
	ret.push(data.input);
	return ret;
}

var parseReceipt = function(data) {
	var ret = [];
	ret.push(data.to);
	ret.push(data.status);
	return ret;
}

var handleOlinkWeb = function(self, method, args) {
	if(method == "enable") {
		var curr = getCurrent();
		var func = args[args.length - 1].callSucc;
		var addr = curr.addr;

		var lang = localStorage.getItem("language");
		if(lang == null) {
			lang = "ch";
		}

		var chain = getActiveChain();
    	if(chain == null) {
    		chain = "ETHG"
    	}
    	System.chain = chain;
    	var chainID = get_chainID();

		var res = addr + "," + lang + "," + chainID;

		self.executeScript({
			code: `${func}('${res}')`
		});
	} else if(method == "request") {
		rpc_core_dapp(args[0].method, args[0].params, function(data) {
			var func = args[args.length - 1].callSucc;
			var res = JSON.stringify(data);
			self.executeScript({
				code: `${func}('${res}')`
			});
		}, function(err) {
			var errc = args[args.length - 1].callFail;
			var ret = JSON.stringify(err);
			self.executeScript({
				code: `${errc}('${ret}')`
			});
		});

	// 	var curr = getCurrent();
	// 	var func = args[args.length - 1].callSucc;
	// 	var addr = Base58.fromAddr(curr.addr);

	// 	self.executeScript({
	// 		code: `${func}('${addr}')`
	// 	});
	// } else if(method == "balance") {
	// 	proxyBalance(Base58.toAddr(args[0]), function(data) {
	// 		var func = args[args.length - 1].callSucc;
	// 		self.executeScript({
	// 			code: `${func}('${data.result}')`
	// 		});
	// 	}, function(err) {
	// 		var errc = args[args.length - 1].callFail;
	// 		self.executeScript({
	// 			code: `${errc}('${err}')`
	// 		});
	// 	});
	// } else if(method == "tx_info") {
	// 	proxyTxInfo(args[0], function(data) {
	// 		var func = args[args.length - 1].callSucc;
	// 		var ret = parseTxInfo(data.result);
	// 		self.executeScript({
	// 			code: `${func}('${ret}')`
	// 		});
	// 	}, function(err) {
	// 		var errc = args[args.length - 1].callFail;
	// 		self.executeScript({
	// 			code: `${errc}('${err}')`
	// 		});
	// 	});
	// } else if(method == "send") { // common tx
	// 	commonSend(Base58.toAddr(System.from), Base58.toAddr(args[0].to), args[0].value, System.priv, function(data) {
	// 		var func = args[args.length - 1].callSucc;
	// 		self.executeScript({
	// 			code: `${func}('${data.result}')`
	// 		});
	// 	}, function(err) {
	// 		var errc = args[args.length - 1].callFail;
	// 		self.executeScript({
	// 			code: `${errc}('${err}')`
	// 		});
	// 	});
	// } else if(method == "sendx") { // contract tx
	// 	contractSend(Base58.toAddr(System.from), Base58.toAddr(args[0].to), "0x" + genHex(args[0].value), "0x" + genFuncHash(args[0].fun_name, args[0].fun_input) + args[0].data, System.priv, function(data) {
	// 		var func = args[args.length - 1].callSucc;
	// 		self.executeScript({
	// 			code: `${func}('${data.result}')`
	// 		});
	// 	}, function(err) {
	// 		var errc = args[args.length - 1].callFail;
	// 		self.executeScript({
	// 			code: `${errc}('${err}')`
	// 		});
	// 	});
	// }  else if(method == "call") {
	// 	proxyOlinkCall(Base58.toAddr(args[0].to), "0x" + genFuncHash(args[0].fun_name, args[0].fun_input) + args[0].data, function(data) {
	// 		var ret = parseOutput(data.result, args[0].output);
	// 		var func = args[args.length - 1].callSucc;

	// 		self.executeScript({
	// 			code: `${func}('${ret}')`
	// 		});
	// 	}, function(err) {
	// 		var errc = args[args.length - 1].callFail;
	// 		self.executeScript({
	// 			code: `${errc}('${err}')`
	// 		});
	// 	});
	// } else if(method == "signtx") {
	// 	contractSign(Base58.toAddr(args[0].from), Base58.toAddr(args[0].to), args[0].value, args[0].data, System.priv, function(data, extra) {
	// 		var func = args[args.length - 1].callSucc;
	// 		var ret = [data, extra];
	// 		self.executeScript({
	// 			code: `${func}('${ret}')`
	// 		});
	// 	}, function(err) {
	// 		var errc = args[args.length - 1].callFail;
	// 		self.executeScript({
	// 			code: `${errc}('${err}')`
	// 		});
	// 	});
	// } else if(method == "tx_receipt") {
	// 	proxyReceipt(args[0], function(data) {
	// 		var func = args[args.length - 1].callSucc;
	// 		var ret = parseReceipt(data.result);
	// 		self.executeScript({
	// 			code: `${func}('${ret}')`
	// 		});
	// 	}, function(err) {
	// 		var errc = args[args.length - 1].callFail;
	// 		self.executeScript({
	// 			code: `${errc}('${err}')`
	// 		});
	// 	});
	// } else if(method == "send_tx") {
	// 	contractSend(Base58.toAddr(args[0].from), Base58.toAddr(args[0].to), args[0].value, args[0].data, System.priv, function(data) {
	// 		var func = args[args.length - 1].callSucc;
	// 		self.executeScript({
	// 			code: `${func}('${data.result}')`
	// 		});
	// 	}, function(err) {
	// 		var errc = args[args.length - 1].callFail;
	// 		self.executeScript({
	// 			code: `${errc}('${err}')`
	// 		});
	// 	});
	} else if(method == "footer_refresh") {
		window.clickRefresh();
	} else if(method == "footer_copy") {
		window.clickCopyUrl();
	} else if(method == "footer_save") {
		window.clickSave();
	} else if(method == "footer_openout") {
		window.clickOpenBrowser();
	} else if(method == "footer_changeuser") {
		window.clickChangeUser();
	} else if(method == "footer_selectuser") {
		window.clickSelectUser(args[0], args[1]);
	} else if(method == "pay_showpass") {
		window.clickShowPass();
	} else if(method == "pay_cancle") {
		window.clickPayCancel();
	} else if(method == "pay_confirm") {
		window.clickTxConfirm(args[0]);
	} else if(method == "pay_confirm_no") {
		window.clickTxNo();
	} else if(method == "open_tokenpocket") {
		var sApp = startApp.set({
			"application": "vip.mytokenpocket"
		}).start(function(values) {
			var func = args[args.length - 1].callSucc;
			self.executeScript({
				code: `${func}('${values}')`
			});
		}, function(err) {
			var errc = args[args.length - 1].callFail;
			self.executeScript({
				code: `${errc}('${err}')`
			});
		});
	}
}
