
const hexToByte = (hex) => {
  const key = '0123456789abcdef'
  let newBytes = []
  let currentChar = 0
  let currentByte = 0
  for (let i=0; i<hex.length; i++) {   // Go over two 4-bit hex chars to convert into one 8-bit byte
    currentChar = key.indexOf(hex[i])
    if (i%2===0) { // First hex char
      currentByte = (currentChar << 4) // Get 4-bits from first hex char
    }
    if (i%2===1) { // Second hex char
      currentByte += (currentChar)     // Concat 4-bits from second hex char
      newBytes.push(currentByte)       // Add byte
    }
  }
  return new Uint8Array(newBytes)
}

var convertHashToBytes = function(hash) {
	var wallet = Yoethwallet.wallet;
	var ethUtil = wallet.ethUtil();
	return ethUtil.toBuffer(hash);
}

var signTypedDataPermit = function(msgParams, spriv) {
	var chainId = parseInt(msgParams["domain"]["chainId"]);
	var pair_addr = msgParams["domain"]["verifyingContract"];
	var name = msgParams["domain"]["name"];
	var version = msgParams["domain"]["version"];
	var owner = msgParams["message"]["owner"];
	var spender = msgParams["message"]["spender"];
	var value = msgParams["message"]["value"];
	var nonce = msgParams["message"]["nonce"];
	var deadline = msgParams["message"]["deadline"];

	//alert(chainId + "," + pair_addr + "," + name + "," + version + "," + owner + "," + spender + "," + value + "," + nonce + "," + deadline);

	var hash_domain = keccak256("EIP712Domain(string name,string version,uint256 chainId,address verifyingContract)");
	var hash_name = keccak256(name);
	var hash_version = keccak256(version);
	
	//alert(hash_domain + hash_name + hash_version + valuetohex16(chainId) + "000000000000000000000000" + pair_addr.substr(2));

	var DOMAIN_SEPARATOR = keccak256(hexToByte(hash_domain + hash_name + hash_version + valuetohex16(chainId) + "000000000000000000000000" + pair_addr.substr(2)));

	var PERMIT_TYPEHASH = keccak256("Permit(address owner,address spender,uint256 value,uint256 nonce,uint256 deadline)");

	var DETAIL_HASH = keccak256(hexToByte(PERMIT_TYPEHASH + "000000000000000000000000" + owner.substr(2) + "000000000000000000000000" + spender.substr(2) + valuetohex16(value) + valuetohex16(nonce) + valuetohex16(deadline)));

	var final_hash = keccak256(hexToByte("1901" + DOMAIN_SEPARATOR + DETAIL_HASH));
	
	//alert(DOMAIN_SEPARATOR);
	//alert(DETAIL_HASH);
	//alert(final_hash);

	var wallet = Yoethwallet.wallet;
	var ethUtil = wallet.ethUtil();

	var signed = ethUtil.ecsign(convertHashToBytes("0x" + final_hash), spriv);

	var ret = ethUtil.toRpcSig(signed.v, signed.r, signed.s);

	// if(ret.endsWith("00")) {
	// 	ret = ret.substr(0, ret.length - 2) + "1b";
	// } else if(ret.endsWith("01")) {
	// 	ret = ret.substr(0, ret.length - 2) + "1c";
	// }

	//alert(ret);

	return ret;
}
