$(function() {
	var lan = getLanguage();

	window.onload = function() {
		changeLang();

		var chain = getCreatedChain();
		if(chain == null) {
			chain = "ETHG";
		}
		System.chain = chain;

		document.getElementById("input_name").value = getDefaultAccName();

		var keys = getScanKeys();
		if(keys != "") {
			document.getElementById("input_keystore").value = keys;
		}
	}

	window.clickImport = function() {
		var accName = document.getElementById("input_name").value;
		var keys = document.getElementById("input_keystore").value;
		var pass = document.getElementById("input_pass").value;
		var passRep = document.getElementById("input_pass_repeat").value;

		var checked = document.getElementById("s11").checked;
		if(!checked) {
			toast(lan.ALERT_AGREE);
			return;
		}

		if (accName == "") {
			toast(lan.LAB_OLINK_ALERT_NAME_NULL);
			return;
		}

		if(!validName(accName)) {
			toast(lan.LAB_OLINK_ALERT_NAME_INVALID);
			return;
		}

		if (!validPass(pass)) {
			toast(lan.LAB_ETHG_CREATEWALLET_INPUT_PASS);
			return;
		}

		// 判定确认密码
		if (pass != passRep) {
			// alert(lan.ALERT_PASSWORD_DIFFERENT);
			toast(lan.ALERT_PASSWORD_INCONSISTENT)
			return;
		}


		var wallet = Yoethwallet.wallet;

		wallet.fromV3String(keys, pass, function(err, keystore) {
			if (err) {
				// alert(err);
				toast(err);
				return;
			}

			var chain = getCreatedChain();
			if(chain == null) {
				chain = "ETHG";
			}
			System.chain = chain;

			var privKey = keystore.getPrivateKey();
			var addr = keystore.getHexAddress(true);
			// 判断地址
			var ais = addrInAccs(addr, chain);
			if (ais[0]) {
				//alert(lan.ALERT_ACCOUNT_EXISTS);
				// another name
				clearScanKeys();
				setAnotherName(addr, accName);
				clearPageStack();
				setCurrent(accName, addr);

				setActiveChain(chain);

				window.location.href = "assets.html";
				return;
			}

			// keystore.toV3String(pass, {}, (err_pass, v3Json) => {
			//     if(err_pass) {
			//         alert(err_pass);
			//         return;
			//     }
			clearScanKeys();

			setActiveChain(chain);

			newAcc(accName, addr, chain);
			setCurrent(accName, addr);

			System.accName = accName;
			System.addr = addr;
			System.priv = privKey;

			// 测试文件系统
			window.saveFile(System.accName, System.addr, System.priv, pass);
		});
	}

	window.saveFile = function(accName, addr, priv, pass) {
		var dataObj = JSON.stringify({
			addr: addr,
			priv: priv,
			pass: pass
		});

		window.localStorage.setItem("olink_priv_" + addr, dataObj);
		clearPageStack();
		window.location.href = "assets.html";
	}
})

$('.pu_bank').on('click', function() {
	clearScanPriv();
	clickPagePrev(true);
})

$('.mn_btn').on('click', function() {
	window.clickImport();
})

$('.external').on('click', function() {
	clickPageNext('userAgreement.html',true);
})
