$(function() {
	var lan = getLanguage();

	var wordlists = {};

	function initWordList() {
		var bip39 = Yoethwallet.wallet.bip39();
		for(var i = 0; i < bip39.wordlists.EN.length; i++) {
			var f = bip39.wordlists.EN[i].substr(0, 1);
			var s = bip39.wordlists.EN[i].substr(1, 1);
			if(wordlists[f] == null) {
				wordlists[f] = {};
			}
			if(wordlists[f][s] == null) {
				wordlists[f][s] = [];
			}
			wordlists[f][s].push(bip39.wordlists.EN[i]);
		}
	}

	window.onload = function() {
		changeLang();

		var chain = getCreatedChain();
		if(chain == null) {
			chain = "ETHG";
		}
		System.chain = chain;

		document.getElementById("input_name").value = getDefaultAccName();

		initWordList();
	}

	window.changeMne = function() {
		var ws = document.getElementById("input_mnemonic").value;
		var wss = ws.split(' ');
		for(var i = 0; i < wss.length; i++) {
			if(wss[i].length >= 2) {
				var fw = wss[i].substr(0, 1);
				var sw = wss[i].substr(1, 1);

				if(wordlists[fw] == null || wordlists[fw][sw] == null) {
					document.getElementById("id_err_tip").innerHTML = (wss[i] + " " + lan.LAB_ETHG_MNEMONICIMPORT_INVALID_MNE);
					document.getElementById("id_err_tip_show").style = "display:";
					return;
				}

				var _flag = false;
				for(var j = 0; j < wordlists[fw][sw].length; j++) {
					if(wordlists[fw][sw][j].startsWith(wss[i])) {
						_flag = true;
						break;
					}
				}
				if(_flag == false) {
					document.getElementById("id_err_tip").innerHTML = (wss[i] + " " + lan.LAB_ETHG_MNEMONICIMPORT_INVALID_MNE);
					document.getElementById("id_err_tip_show").style = "display:";
					return;
				}
			}
		}
		document.getElementById("id_err_tip").innerHTML = "";
		document.getElementById("id_err_tip_show").style = "display:none";
	}

	window.clickImport = function() {
		var accName = document.getElementById("input_name").value;
		var mne = document.getElementById("input_mnemonic").value;
		var pass = document.getElementById("input_pass").value;
		var passRep = document.getElementById("input_pass_repeat").value;

		var checked = document.getElementById("s11").checked;
		if(!checked) {
			toast(lan.ALERT_AGREE);
			return;
		}

		if (accName == "") {
			toast(lan.LAB_OLINK_ALERT_NAME_NULL);
			return;
		}

		if(!validName(accName)) {
			toast(lan.LAB_OLINK_ALERT_NAME_INVALID);
			return;
		}

		if (!validPass(pass)) {
			toast(lan.LAB_ETHG_CREATEWALLET_INPUT_PASS);
			return;
		}

		// 判定确认密码
		if (pass != passRep) {
			// alert(lan.ALERT_PASSWORD_DIFFERENT);
			toast(lan.ALERT_PASSWORD_INCONSISTENT)
			return;
		}

		var wallet = Yoethwallet.wallet;
		var priv;

		var bip39 = Yoethwallet.wallet.bip39();
		var HDKey = Yoethwallet.wallet.HDKey();


		if(!bip39.validateMnemonic(mne)) {
			toast(lan.LAB_ETHG_MNEMONICIMPORT_INVALID_MNE);
			return;
		}

		var selectedPath = "m/44\'/60\'/0\'/0/0";
		var key = HDKey.fromMasterSeed(bip39.mnemonicToSeed(mne));
		priv = key.derive(selectedPath).privateKey;

		wallet.fromPrivateKey(priv, function(err, keystore) {
			if (err) {
				// alert(err);
				toast(err);
				return;
			}

			var chain = getCreatedChain();
			if(chain == null) {
				chain = "ETHG";
			}

			System.chain = chain;

			var privKey = keystore.getPrivateKey();
			var addr = keystore.getHexAddress(true);
			// 判断地址
			var ais = addrInAccs(addr, chain);
			if (ais[0]) {
				//alert(lan.ALERT_ACCOUNT_EXISTS);
				// another name
				setAnotherName(addr, accName);
				clearPageStack();
				setCurrent(accName, addr);

				setAddrMnemonic(keystore.getHexAddress(true), mne);
				
				setActiveChain(chain);

				window.location.href = "assets.html";
				return;
			}

			// keystore.toV3String(pass, {}, (err_pass, v3Json) => {
			//     if(err_pass) {
			//         alert(err_pass);
			//         return;
			//     }

			

			setActiveChain(chain);

			newAcc(accName, addr, chain);
			setCurrent(accName, addr);

			System.accName = accName;
			System.addr = addr;
			System.priv = privKey;

			setAddrMnemonic(keystore.getHexAddress(true), mne);

			// 测试文件系统
			window.saveFile(System.accName, System.addr, System.priv, pass);
		});
	}

	window.saveFile = function(accName, addr, priv, pass) {
		var dataObj = JSON.stringify({
			addr: addr,
			priv: priv,
			pass: pass
		});

		window.localStorage.setItem("olink_priv_" + addr, dataObj);
		clearPageStack();
		window.location.href = "assets.html";
	}
})

$('.pu_bank').on('click', function() {
	clearScanPriv();
	clickPagePrev(true);
})

$('.mn_btn').on('click', function() {
	window.clickImport();
})

$('#input_mnemonic').on('input', function() {
	window.changeMne();
})

$('.external').on('click', function() {
	clickPageNext('userAgreement.html',true);
})
