$(function() {
	var lan = getLanguage();

	window.onload = function() {
		changeLang();

		var chain = getActiveChain();
		if(chain == null) {
			chain = "ETHG"
		}
		System.chain = chain;

		//System.chain = "ETHG";
		var curr = getCurrent();
		System.addr = curr.addr;

		rpc_getBalance(curr.addr, function(data_bal) {
			document.getElementById("lab_balance").innerHTML = showAmount(data_bal);
		}, function(err_bal) {

		});

		window.renderTokens();
	}

	window.loadTokenBalance = function(token) {
		rpc_ethCall(token, get_erc20_balance(System.addr), function(data_bal) {
			document.getElementById("lab_token_balance_" + token).innerHTML = showAmount(data_bal);

		}, function(err_symbol) {
			
		});
	}

	window.clickDelToken = function(token) {
		mui.confirm(lan.LAB_CONFIRM_DELETE_TOKEN, lan.LAB_ETHG_CREATEWALLET_TIP, [lan.LAB_ETHG_ADDTOKENS_CANCEL, lan.LAB_ETHG_ADDTOKENS_OK], function(obj) {
			if(obj.index == 1) {
				delTokenToCache(System.chain, token);
				window.renderTokens();
			}
		})
	}

	window.loadTokenImg = function(token) {
		setTimeout(function() {
			document.getElementById("id_img_token_" + token).src = "https://www.etherumgold.me/autoplay/token/" + System.chain + "/" + token + ".png";
			document.getElementById("id_img_token_" + token).addEventListener('error', function(e) {
				e.target.src = "image/e_70.png";
			})
		}, 40);
	}

	window.renderTokens = function() {
		document.getElementById("lab_token_name").innerHTML = get_chainSymbol();
		if(System.chain == "ETHG") {
			document.getElementById("id_img_token").src = "image/e_10.png";
		} else if(System.chain == "ETH") {
			document.getElementById("id_img_token").src = "image/e_14.png";
		} else if(System.chain == "BNB") {
			document.getElementById("id_img_token").src = "image/e_12.png";
		} else if(System.chain == "HT") {
			document.getElementById("id_img_token").src = "image/e_75.png";
		}

		var tokens = getTokenToCache();
		if(tokens != null) {
			var html = "";

			for(var i = 0; i < tokens.tokenList.length; i++) {
				if(tokens.tokenList[i].chain == System.chain) {
					var tokenImg = ((tokens.tokenList[i].contrAddr == getUsdtAddr()) ? "image/usdt.png" : "image/e_70.png");
					html += `<li class="display_flex align-items_center">
							<div class="list_img">
								<img id="id_img_token_{1}" src="{3}" alt="" srcset="">
							</div>
							<div class="flex_1">
								<div class="list_title">
									{0}
								</div>
								<div class="list_site">
									{2}
						
								</div>
								<div class="list_yue" id="lab_token_balance_{1}">
									0
								</div>
							</div>
							<div class="list_right_img" onclick="javascript:window.clickDelToken('{1}')">
								<img src="image/e_32.png" alt="" srcset="">
							</div>
						</li>`.format(tokens.tokenList[i].symbol, tokens.tokenList[i].contrAddr.toLowerCase(), lessAddr(tokens.tokenList[i].contrAddr, 20), tokenImg);

					var token = tokens.tokenList[i].contrAddr;
					var inter = 47 * (i + 1);
					setTimeout(function(c) {
						window.loadTokenBalance(c);
						window.loadTokenImg(c);
					}(token), inter);
				}
			}

			document.getElementById("id_list_tokens").innerHTML = html;
		}
	}
})

$('.pu_bank').on('click', function() {
	clickPagePrev(true);
})

$('.m_export_method').on('click', function() {
	clickPageNext('exportMethod.html', true);
})
