$(function() {
	var lan = getLanguage();
	var tokenType = {};

	var recordType = 1;

	var data_list = {};

	var copy_clicked = false;

	var mescroll = new MeScroll("id_mescroll", {
		down: {
			auto: false, 
			callback: downCallback
		},
		up: {
			auto: false,
			use: false,
			callback: null
		}
	});

	function downCallback() {
		window.refresh(function() {
			mescroll.endSuccess();
		})
	}

	window.copyText = function(text) {
		copy_clicked = true;
		cordova.plugins.clipboard.copy(text, function(data_copy) {
			toast(lan.ALERT_COPY_OK);
		}, function(err_copy) {
			toast(err_copy);
		});
	}

	window.clickRecord = function(typ) {
		recordType = typ;
		// render
		for(var i = 1; i <= 3; i++) {
			if(typ == i) {
				if(!$('#id_record_' + i).hasClass('active')) {
					$('#id_record_' + i).addClass('active');
				}
			} else {
				if($('#id_record_' + i).hasClass('active')) {
					$('#id_record_' + i).removeClass('active');
				}
			}
		}
		// loading
		renderList();
	}

	window.clickTx = function(router) {
		if(copy_clicked == false) {
			window.clickPageNext(router);
		} else{
			copy_clicked = false;
		}
	}

	function mergeList(addr) {
		var sents = getSents(System.chain, tokenType.tokenAddr, addr);
		var tmpList = [];
		if(System.chain == "ETHG") {
			tmpList = data_list.list;
			data_list.list = [];
		} else {
			tmpList = data_list.result;
			data_list.result = [];
		}
		data_list.list = [];
		for(var i = 0; i < sents.length; i++) {
			var flag = true;
			for(var j = 0; j < tmpList.length; j++) {
				if(sents[i].hash == tmpList[j].hash) {
					flag = false;
					break;
				}
			}
			if(flag) {
				if(System.chain == "ETHG") {
					data_list.list.push(sents[i]);
				} else {
					data_list.result.push(sents[i]);
				}
			}
		}
		for(var k = 0; k < tmpList.length; k++) {
			if(System.chain == "ETHG") {
				data_list.list.push(tmpList[k]);
			} else {
				data_list.result.push(tmpList[k]);
			}
		}
	}

	var renderList = function(cb_succ) {
		var curr = getCurrent();

		mergeList(curr.addr);

		if(System.chain == "ETHG") {
			if(tokenType.tokenAddr == "0") {
				var html = "";
				for(var i = 0; i < data_list.list.length; i++) {
					if((recordType == 2 && data_list.list[i].from != curr.addr) || (recordType == 3 && data_list.list[i].from == curr.addr)) {
						continue;
					}

					var transTypeClass = ((data_list.list[i].from == curr.addr) ? "tran_geujieout" : "tran_geujie");
					var transImg = ((data_list.list[i].from == curr.addr) ? "image/e_53.png" : "image/e_74.png");

					html += `
					<div class="tran_list_box display_flex align-items_center" >
					<div class="tran_imgs">
						<img src="{13}" style="width:1.2rem;height:1.2rem;" alt="" srcset="">
					</div>
					<div class="flex_1">
						<div class="tran_jkelfe display_flex align-items_center">
							<div class="tran_ghekd" id="transactionDetails.html#{5}#{6}#{7}#{8}#{9}#{10}#{4}">
								{0}

							</div>
						
						</div>
						<div class="tran_rteuh">
							{1} 
						</div>
					</div>
					<div class="{12}" onclick="javascript:clickTx('transactionDetails.html#{5}#{6}#{7}#{8}#{9}#{10}#{4}')">
						{2}{3} {4}
					</div>
				</div>`.format(lessAddr((data_list.list[i].from == curr.addr) ? data_list.list[i].to : data_list.list[i].from, 10), getLocalTime(data_list.list[i].time), 
					(data_list.list[i].from == curr.addr) ? "-" : "+", showAmount(data_list.list[i].value), "ETHG", data_list.list[i].hash,
					data_list.list[i].from, data_list.list[i].to, data_list.list[i].value, data_list.list[i].time, data_list.list[i].blockNumber, (data_list.list[i].from == curr.addr) ? data_list.list[i].to : data_list.list[i].from, transTypeClass, transImg);
				}
				document.getElementById("list_txs").innerHTML = html;
			} else {
				var html = "";
				for(var i = 0; i < data_list.list.length; i++) {
					data_list.list[i].from = data_list.list[i].from.replace("0x000000000000000000000000", "0x");
					data_list.list[i].to = data_list.list[i].to.replace("0x000000000000000000000000", "0x");

					if((recordType == 2 && data_list.list[i].from != curr.addr) || (recordType == 3 && data_list.list[i].from == curr.addr)) {
						continue;
					}

					var transTypeClass = ((data_list.list[i].from == curr.addr) ? "tran_geujieout" : "tran_geujie");
					var transImg = ((data_list.list[i].from == curr.addr) ? "image/e_53.png" : "image/e_74.png");

					html += `
					<div class="tran_list_box display_flex align-items_center" >
					<div class="tran_imgs">
						<img src="{13}" style="width:1.2rem;height:1.2rem;" alt="" srcset="">
					</div>
					<div class="flex_1">
						<div class="tran_jkelfe display_flex align-items_center">
							<div class="tran_ghekd" id="transactionDetails.html#{5}#{6}#{7}#{8}#{9}#{10}#{4}">
								{0}

							</div>
						
						</div>
						<div class="tran_rteuh">
							{1} 
						</div>
					</div>
					<div class="{12}" onclick="javascript:clickTx('transactionDetails.html#{5}#{6}#{7}#{8}#{9}#{10}#{4}')">
						{2}{3} {4}
					</div>
				</div>`.format(lessAddr((data_list.list[i].from == curr.addr) ? data_list.list[i].to : data_list.list[i].from, 10), getLocalTime(data_list.list[i].time), 
					(data_list.list[i].from == curr.addr) ? "-" : "+", showAmount(data_list.list[i].value, tokenType.tokenDecimal), tokenType.tokenName, data_list.list[i].hash,
					data_list.list[i].from, data_list.list[i].to, data_list.list[i].value, data_list.list[i].time, data_list.list[i].blockNumber, (data_list.list[i].from == curr.addr) ? data_list.list[i].to : data_list.list[i].from, transTypeClass, transImg)
				}
				document.getElementById("list_txs").innerHTML = html;
			}
		} else {
			if(tokenType.tokenAddr == "0") {
				var html = "";
				for(var i = 0; i < data_list.result.length; i++) {
					if((recordType == 2 && data_list.result[i].from != curr.addr) || (recordType == 3 && data_list.result[i].from == curr.addr)) {
						continue;
					}

					var transTypeClass = ((data_list.result[i].from == curr.addr) ? "tran_geujieout" : "tran_geujie");
					var transImg = ((data_list.result[i].from == curr.addr) ? "image/e_53.png" : "image/e_74.png");

					html += `
					<div class="tran_list_box display_flex align-items_center" >
					<div class="tran_imgs">
						<img src="{13}" style="width:1.2rem;height:1.2rem;" alt="" srcset="">
					</div>
					<div class="flex_1">
						<div class="tran_jkelfe display_flex align-items_center">
							<div class="tran_ghekd" id="transactionDetails.html#{5}#{6}#{7}#{8}#{9}#{10}#{4}">
								{0}

							</div>
						
						</div>
						<div class="tran_rteuh">
							{1} 
						</div>
					</div>
					<div class="{12}" onclick="javascript:clickTx('transactionDetails.html#{5}#{6}#{7}#{8}#{9}#{10}#{4}')">
						{2}{3} {4}
					</div>
				</div>`.format(lessAddr((data_list.result[i].from == curr.addr) ? data_list.result[i].to : data_list.result[i].from, 10), getLocalTime(data_list.result[i].timeStamp), 
					(data_list.result[i].from == curr.addr) ? "-" : "+", showAmount(data_list.result[i].value), get_chainSymbol(), data_list.result[i].hash,
					data_list.result[i].from, data_list.result[i].to, data_list.result[i].value, data_list.result[i].timeStamp, data_list.result[i].blockNumber, (data_list.result[i].from == curr.addr) ? data_list.result[i].to : data_list.result[i].from, transTypeClass, transImg)
				}
				document.getElementById("list_txs").innerHTML = html;
			} else {
				var html = "";
				for(var i = 0; i < data_list.result.length; i++) {

					if((recordType == 2 && data_list.result[i].from != curr.addr) || (recordType == 3 && data_list.result[i].from == curr.addr)) {
						continue;
					}

					var transTypeClass = ((data_list.result[i].from == curr.addr) ? "tran_geujieout" : "tran_geujie");
					var transImg = ((data_list.result[i].from == curr.addr) ? "image/e_53.png" : "image/e_74.png");

					html += `
					<div class="tran_list_box display_flex align-items_center" >
					<div class="tran_imgs">
						<img src="{13}" style="width:1.2rem;height:1.2rem;" alt="" srcset="">
					</div>
					<div class="flex_1">
						<div class="tran_jkelfe display_flex align-items_center">
							<div class="tran_ghekd" id="transactionDetails.html#{5}#{6}#{7}#{8}#{9}#{10}#{4}">
								{0}

							</div>
						
						</div>
						<div class="tran_rteuh">
							{1} 
						</div>
					</div>
					<div class="{12}" onclick="javascript:clickTx('transactionDetails.html#{5}#{6}#{7}#{8}#{9}#{10}#{4}')">
						{2}{3} {4}
					</div>
				</div>`.format(lessAddr((data_list.result[i].from == curr.addr) ? data_list.result[i].to : data_list.result[i].from, 10), getLocalTime(data_list.result[i].timeStamp), 
					(data_list.result[i].from == curr.addr) ? "-" : "+", showAmount(data_list.result[i].value, tokenType.tokenDecimal), tokenType.tokenName, data_list.result[i].hash,
					data_list.result[i].from, data_list.result[i].to, data_list.result[i].value, data_list.result[i].timeStamp, data_list.result[i].blockNumber, (data_list.result[i].from == curr.addr) ? data_list.result[i].to : data_list.result[i].from, transTypeClass, transImg)
				}
				document.getElementById("list_txs").innerHTML = html;
			}
		}

		if(cb_succ) {
			cb_succ();
		}

		$('.tran_ghekd').on('click', function() {
			var id = $(this).attr('id');
			window.clickTx(id);
		})
	}

	window.onload = function() {
		$("#id_mescroll").height(window.screen.height - 310);
		$("#list_txs").height(window.screen.height - 300);
		changeLang();

		var chain = getActiveChain();
    	if(chain == null) {
    		chain = "ETHG"
    	}
    	System.chain = chain;

    	window.refresh();
    	setInterval(function() {
    		window.refresh();
    	}, 13000);
    }

   	window.refresh = function(cb_succ) {
		var curr = getCurrent();
		var chain = System.chain;

		tokenType = getCurrentTokenType();

		if(chain == "ETHG") {
			if(tokenType.tokenAddr == "0") {
				document.getElementById("id_token_show_contract").style = "display:none;"

				document.getElementById("id_token_name").innerHTML = get_chainSymbol();
				document.getElementById("id_token_img").src = "image/e_10.png";

				rpc_getBalance(curr.addr, function(data_bal) {
		    		document.getElementById("lab_balance").innerHTML = showAmount(data_bal);

		    	}, function(err_bal) {

		    	});

				proxyTxs(curr.addr, 1, 100, function(data_list_x) {
					data_list = data_list_x;
					renderList(cb_succ);
				}, function(err_txs) {

				});
			} else {
				document.getElementById("id_token_name").innerHTML = tokenType.tokenName;
				document.getElementById("id_token_addr").innerHTML = lessAddr(tokenType.tokenAddr, 25);
				document.getElementById("id_token_img").src = "https://www.etherumgold.me/autoplay/token/" + System.chain + "/" + tokenType.tokenAddr + ".png";
				document.getElementById("id_token_img").addEventListener('error', function(e) {
					e.target.src = "image/e_70.png";
				})

				rpc_ethCall(tokenType.tokenAddr, get_erc20_balance(curr.addr), function(data_bal) {
					document.getElementById("lab_balance").innerHTML = showAmount(data_bal, tokenType.tokenDecimal);

				}, function(err_symbol) {
					
				});

				proxyErcTxs(curr.addr, tokenType.tokenAddr, function(data_list_x) {
					data_list = data_list_x;
					renderList(cb_succ);
				}, function(err_txs) {

				});
			}
		} else {
			if(tokenType.tokenAddr == "0") {
				document.getElementById("id_token_show_contract").style = "display:none;"

				document.getElementById("id_token_name").innerHTML = get_chainSymbol();
				//document.getElementById("id_token_img").src = "image/e_14.png";
				document.getElementById("id_token_img").src = get_chainImg();

				rpc_getBalance(curr.addr, function(data_bal) {
		    		document.getElementById("lab_balance").innerHTML = showAmount(data_bal);

		    	}, function(err_bal) {

		    	});

				outerProxyTxs(curr.addr, function(data_list_x) {
					data_list = data_list_x;
					renderList(cb_succ);
				}, function(err_list) {

				});
			} else {
				var tokenImg = ((tokenType.tokenAddr == getUsdtAddr()) ? "image/usdt.png" : "image/e_70.png");
				document.getElementById("id_token_name").innerHTML = tokenType.tokenName;
				document.getElementById("id_token_addr").innerHTML = lessAddr(tokenType.tokenAddr, 25);
				document.getElementById("id_token_img").src = "https://www.etherumgold.me/autoplay/token/" + System.chain + "/" + tokenType.tokenAddr + ".png";
				document.getElementById("id_token_img").addEventListener('error', function(e) {
					e.target.src = "image/e_70.png";
				})

				rpc_ethCall(tokenType.tokenAddr, get_erc20_balance(curr.addr), function(data_bal) {
					document.getElementById("lab_balance").innerHTML = showAmount(data_bal, tokenType.tokenDecimal);

				}, function(err_symbol) {
					
				});

				outerProxyTokenTxs(curr.addr, tokenType.tokenAddr, function(data_list_x) {
					data_list = data_list_x;
					renderList(cb_succ);
				}, function(err_txs) {

				});
			}
		}
	}

	window.clickSend = function() {
		setCurrentTokenType(tokenType.tokenName, tokenType.tokenAddr, '', tokenType.tokenDecimal);
		clickPageNext('transferAccounts.html',true);
	}

	window.clickReceive = function() {
		clickPageNext('collection.html',true);
	}

	window.clickCopyContract = function() {
		cordova.plugins.clipboard.copy(tokenType.tokenAddr, function(data_copy) {
			toast(lan.LAB_DEX_QUICKPRESS_COPY_TIP, 5000);
		}, function(err_copy) {
			toast(err_copy);
		});
	}

	window.clickSeeDetail = function() {
		clickPageNext('tokenDetail.html#' + tokenType.tokenAddr);
	}
})

$('.pu_bank').on('click', function() {
	clickPagePrev(true);
})

$('#id_record_1').on('click', function() {
	window.clickRecord(1);
})

$('#id_record_2').on('click', function() {
	window.clickRecord(2);
})

$('#id_record_3').on('click', function() {
	window.clickRecord(3);
})

$('.m_copy_contract').on('click', function() {
	window.clickCopyContract();
})

$('.m_send').on('click', function() {
	window.clickSend();
})

$('.m_receive').on('click', function() {
	window.clickReceive();
})

