// address
// balance
// tx_info
// send
// contract
//    at
//    call
//    send

window.ethereum = {
	selectedAddress: "000",
	chainId: "",
	language: "",

	Helper: {
		getCallBackName: function() {
			var id = 10000;
			return function() {
				id += 1;
				return 'olink_callback_' + id;
			}
		}(),

		handle: function(method, args, cb_succ, cb_fail) {
			var callNameSucc = ethereum.Helper.getCallBackName();
			var callNameFail = ethereum.Helper.getCallBackName();

			var selfSucc = cb_succ;
			var selfFail = cb_fail;

			window[callNameSucc] = function(data) {
				if(selfSucc) {
					selfSucc(data);
				}
				delete window[callNameSucc];
				delete window[callNameFail];
			};
			window[callNameFail] = function(err) {
				if(selfFail) {
					selfFail(err);
				}
				delete window[callNameSucc];
				delete window[callNameFail];
			};

			args.push({
				callSucc: callNameSucc,
				callFail: callNameFail
			});

			// if(args.length > 1) {
			// 	webkit.messageHandlers.cordova_iab.postMessage(JSON.stringify({
			// 		method: method,
			// 		args: args,
			// 	}));
			// }

			window.postMessage({
				method: method,
				args: args,
				chainId: ethereum.chainId,
				selectedAddress: ethereum.selectedAddress
			});

		},
	},

	enable: function() {
		return new Promise(function(resolve, reject) {
			ethereum.Helper.handle("enable", [0], function(data) {
				var res = data.split(',')

				ethereum.selectedAddress = res[0];

				ethereum.language = res[1];

				ethereum.chainId = Number(res[2]);
				// alert(ethereum.chainID);

				resolve(ethereum.selectedAddress);
			}, function(err) {
				reject(err);
			});
		});
	},

	request: function(obj) {
		return new Promise(function(resolve, reject) {
			ethereum.Helper.handle("request", [obj], function(data) {
				//alert(data);
				if(obj.method == "eth_sendTransaction") {
					resolve(data)
				} else {
					resolve(data);
				}
			}, function(err) {
				reject(JSON.parse(err));
			});
		});
	}
};

window.addEventListener("message", function(e) {
	if(e.data.func != null) {
		//alert(e.data.func);
		window[e.data.func](e.data.ret);
	} else if(e.data.errc != null) {
		window[e.data.errc](e.data.err);
	}
});

window.ethereum.enable();
